clear;
%---------------INPUT DATA POINTS (=abscissa measurements): ---------------------
fid = fopen('Astrometry.txt','r');  %input file  *.dat, open only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid);
    if i ~= 1
       if row ~= -1
         A=sscanf(row,'%f');
         YearAstr(i-1)=A(1);
         Separ(i-1)=A(2);
         PosAng(i-1)=A(3);
         Wght(i-1)=A(4);
     end
    end
end
status = fclose('all');
clear A row fid status;
PocetAstr=i-2;   %pocet astrometrickych mereni 
%----------------------------------------------------------------

%----------------INPUT PARAMETERS: ----------------------
fid = fopen('Parameters.txt','r');  %input file  *.in  with the initial LITE parameters, only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid);
    if i == 1
        BBB = strread(row, '%s', 'delimiter', ' ');
        Star = cellstr([BBB(1)]);
%         Star = cellstr([BBB(1) BBB(2) BBB(3) BBB(4) BBB(5) BBB(6) BBB(7) BBB(8) BBB(9) BBB(10)]); 
%         Star = cellstr(BBB);
        Star = Star';
    else
       if row ~= -1
         A=sscanf(row,'%f');
         Y(i-1)=A(1);
         F(i-1)=A(2);
       end
    end
end
status = fclose('all');      %close the file
clear A row i fid status BBB;    %it is better to clear all unnecessary variables from the memory
Y=Y';
%------------------------------------------------------------

p3=Y(1);    %here are the 7 astrometric parameters from the Y matrix
p3F=F(1);
t0=Y(2);
t0F=F(2);
e3=Y(3);
e3F=F(3);
a=Y(4);
aF=F(4);
i3=Y(5);
i3F=F(5);
Omega=Y(6);
OmegaF=F(6);
omeg3=Y(7);
omeg3F=F(7);
clear Y;

MaxExc=0.95;

alfa=PosAng;
r=Separ;
year=YearAstr;
vaha=Wght;
j=0;
pocetvyrazenych=0;
clear PosAng Separ YearAstr Wght;

for i=1:PocetAstr
    if vaha(i)~= 0     %zde vyradime body co maji vahu = 0
        j=j+1;
        PosAng(j)=alfa(i);
        Separ(j)=r(i);
        YearAstr(j)=year(i);
        Wght(j)=vaha(i);
    elseif vaha(i) == 0
        pocetvyrazenych=pocetvyrazenych+1;
        PosAngVyraz(pocetvyrazenych)=alfa(i);
        SeparVyraz(pocetvyrazenych)=r(i);
        YearAstrVyraz(pocetvyrazenych)=year(i);
        WghtVyraz(pocetvyrazenych)=vaha(i);
    end
end
PocetAstrPouzitych=j;    %pocet opravdove pouzitych, s vahou > 0
clear r alfa year vaha;

xBody=(-1)*Separ.*sin(PosAng*pi/180);   %zde jsou souradnice bodu mereni
yBody=Separ.*cos(PosAng*pi/180);
% xBodyVyraz=(-1)*SeparVyraz.*sin(PosAngVyraz*pi/180);
% yBodyVyraz=SeparVyraz.*cos(PosAngVyraz*pi/180);
clear SeparVyraz PosAngVyraz;

for i = 1: PocetAstrPouzitych
    HJD(i)=YearToJul(YearAstr(i));
end

% for i = 1: pocetvyrazenych
%     HJDVyraz(i)=YearToJul(YearAstrVyraz(i));
% end

j=0;
for HJDKrivky = YearToJul(YearAstr(1)):(p3/2000):(YearToJul(YearAstr(1))+p3)     %pro vykresleni krivky pohybu
    j=j+1;
    Hodnota = FcniHodnotaAstrometr(HJDKrivky,t0,p3,e3,a,Omega,omeg3,i3);
    xKrivka(j) = Hodnota(1);     %zde souradnice bodu krivky
    yKrivka(j) = Hodnota(2);
    clear Hodnota;
end
clear HJDKrivky;

j=0;
for i = 1:PocetAstrPouzitych     %zde jen teoreticke body na krivce pohybu
    j=j+1;
    Hodnota = FcniHodnotaAstrometr(HJD(i),t0,p3,e3,a,Omega,omeg3,i3);
    xOdBodu(j) = Hodnota(1);     %zde souradnice bodu krivky
    yOdBodu(j) = Hodnota(2);
    clear Hodnota;
end

% j=0;
% for i = 1:pocetvyrazenych     %zde jen teoreticke body na krivce pohybu
%     j=j+1;
%     HodnotaVyraz = FcniHodnotaAstrometr(HJDVyraz(i),t0,p3,e3,a,Omega,omeg3,i3);
%     xOdBoduVyraz(j) = HodnotaVyraz(1);     %zde souradnice bodu krivky
%     yOdBoduVyraz(j) = HodnotaVyraz(2);
%     clear HodnotaVyraz;
% end

%-----------  figure 1  = before computation  ------------------>
figure(1);
plot(xBody,yBody,'.','MarkerSize',12);    %namerene body
hold on
% plot(xBodyVyraz,yBodyVyraz,'o','MarkerSize',3);    %namerene body
plot(0,0,'kx','MarkerSize',12);          %stred obehu
plot(xOdBodu,yOdBodu,'r.','MarkerSize',7);  %body na teoreticke krivce
% plot(xOdBoduVyraz,yOdBoduVyraz,'r.','MarkerSize',6);  %body na teoreticke krivce
plot(xKrivka,yKrivka,'k.','MarkerSize',1);             % krivka samotna
for i = 1:PocetAstrPouzitych
    X=[xOdBodu(i),xBody(i)];
    Y=[yOdBodu(i),yBody(i)];
    line(X,Y);
    clear X Y;
end
% for i = 1:pocetvyrazenych
%     XVyraz=[xOdBoduVyraz(i),xBodyVyraz(i)];
%     YVyraz=[yOdBoduVyraz(i),yBodyVyraz(i)];
%     line(XVyraz,YVyraz);
%     clear XVyraz YVyraz;
% end
xlabel('RA[arcsec]');
ylabel('DE[arcsec]');
% axis([-0.09 0.125 -0.09 0.125]);
set(gca,'PlotBoxAspectRatio',[1 1 1]);
hold off
%-------------------------------------------------------------------
clear xKrivka yKrivka;

param=7;     %number of parameters to fit (only 7 astrometric parameters)
alfa=1.0;     %parameters of the simplex itself:
beta=0.35;
gama=2.0;
delta=0.5;

chisqr=CelkemAstro(PocetAstrPouzitych,Wght,HJD,t0,p3,e3,a,Omega,omeg3,i3,xBody,yBody);
number=(PocetAstrPouzitych/chisqr); %round(PocetAstrPouzitych/chisqr);
Wght=number*Wght;
sigma=sqrt(1./Wght);
chisqr0=CelkemAstro(PocetAstrPouzitych,Wght,HJD,t0,p3,e3,a,Omega,omeg3,i3,xBody,yBody);

Output=[YearAstr; PosAng; Separ; sigma];

clear PosAng Separ;

% %-------------- O U T P U T --------------->>>
% fid = fopen('Star.out','w');
% fprintf(fid,'%s\n','%V819Her - Year - Pos.Angle - Separ - sigma ');
% fprintf(fid,'%6.6f   %4.3f   %4.4f    %8.7f\n',Output);
% status=fclose('all');
% %=============================================

degOfFree=PocetAstrPouzitych-param;

deltap3=0;
deltat0=0;
deltae3=0;
deltaa=0;
deltaOmega=0;
deltaomeg3=0;
deltai3=0;

PocitadloVnejsi=0;
PocitadloProGraf=0;

count = input('How many steps in one calculation of the simplex algorithm? \n (a few, depends on the speed of the computer): ');
disp([' ']);
input('Now the numbers on the screen represent (decreasing) sum \nof the square residuals from all minima times \nin the best vertex of the actual simplex.');

contin = 1;
while contin == 1
PocitadloVnejsi=PocitadloVnejsi+1;
    %---------------- HERE THE SIMPLEX ALGORITHM!!! ----------------->
    if p3F == 1
        p3D=p3+random('Normal',0,5000,1,param+1);
        p3D(1)=p3;
    else
        p3D=p3+random('Normal',0,0,1,param+1);
        p3D(1)=p3;
    end
    
    if t0F == 1
        t0D=t0+random('Normal',0,5000,1,param+1);
        t0D(1)=t0;
    else
        t0D=t0+random('Normal',0,0,1,param+1);
        t0D(1)=t0;
    end
    
    if e3F == 1
        e3D=e3+random('Normal',0,0.025,1,param+1);
        e3D(1)=e3;
    else
        e3D=e3+random('Normal',0,0.0,1,param+1);
        e3D(1)=e3;
    end
    
    if aF == 1
        aD=a+random('Normal',0,0.05,1,param+1);
        aD(1)=a;
    else
        aD=a+random('Normal',0,0.0,1,param+1);
        aD(1)=a;
    end
    
    if i3F == 1
        i3D=i3+random('Normal',0,110,1,param+1);
        i3D(1)=i3;
    else
        i3D=i3+random('Normal',0,0,1,param+1);
        i3D(1)=i3;
    end
    
    if OmegaF == 1
        OmegaD=Omega+random('Normal',0,120.0,1,param+1);
        OmegaD(1)=Omega;
    else
        OmegaD=Omega+random('Normal',0,0.0,1,param+1);
        OmegaD(1)=Omega;
    end
    
    if omeg3F == 1
        omeg3D=omeg3+random('Normal',0,135.0,1,param+1);
        omeg3D(1)=omeg3;
    else
        omeg3D=omeg3+random('Normal',0,0.0,1,param+1);
        omeg3D(1)=omeg3;
    end
    
    for i = 1:param+1
       if e3D(i) >= MaxExc
          e3D(i)=MaxExc;
       end
    end
    for i = 1:param+1
       if p3D(i) <= 0
          p3D(i)=abs(p3D(i));
       end
    end
    
    konst=350;
    abacus=konst+1;
    fl=0.001;
    fl0=0;

    for i = 1:konst+1
        sumactvercu(i)=0;
    end
    sumactvercu(abacus)=1;
  while sumactvercu(abacus) ~= sumactvercu(abacus-konst)   %podminka zastaveni, kdyz se jiz suma ctvercu nemeni!
    fl0=fl;
    abacus=abacus+1;

    %----------zde funkcni hodnoty od vsech mereni, ode vsech parametru --------
    for j=1:param+1
        SumaCtvercuAstr(j) = CelkemAstro(PocetAstrPouzitych,Wght,HJD,t0D(j),p3D(j),e3D(j),aD(j),OmegaD(j),omeg3D(j),i3D(j),xBody,yBody);
        
        chisqr(j) = SumaCtvercuAstr(j);
        if abs(chisqr(j) - chisqr0) <  degOfFree+3 %param+1
            deltap30=abs(p3D(j)-p3);
            deltat00=abs(t0D(j)-t0);
            deltae30=abs(e3D(j)-e3);
            deltaa0=abs(aD(j)-a);
            deltaOmega0=abs(OmegaD(j)-Omega);
            deltaomeg30=abs(omeg3D(j)-omeg3);
            deltai30=abs(i3D(j)-i3);
            if deltap30 > deltap3
                deltap3=deltap30;
            end
            if deltat00 > deltat0
                deltat0=deltat00;
            end
            if deltae30 > deltae3
                deltae3=deltae30;
            end
            if deltaa0 > deltaa
                deltaa=deltaa0;
            end
            if deltaOmega0 > deltaOmega
                deltaOmega=deltaOmega0;
            end
            if deltaomeg30 > deltaomeg3
                deltaomeg3=deltaomeg30;
            end
            if deltai30 > deltai3
                deltai3=deltai30;
            end
        end
        
    end
    %---------------------------------------------------------------------------
    
    Sort0=sort(SumaCtvercuAstr);     %sort the vector from the smallest element -> fh is the highest, fl the smallest
    fh=Sort0(param+1);
    fs=Sort0(param);
    fl=Sort0(1);
    sumactvercu(abacus)=fl;   %nejlepsi, nejmensi suma ctvercu odchylek
    
    if mod(abacus,20)==0
        disp(['Sum of square residuals: ', num2str(fl,25), '  Number of iterations: ', int2str(abacus-konst), '/', int2str(PocitadloVnejsi), '/',int2str(count),]);
        PocitadloProGraf=PocitadloProGraf+1;
        SumaProGraf(PocitadloProGraf)=fl;  
    end
    
    for i=1:param+1
        if SumaCtvercuAstr(i)==Sort0(param+1)     %gives the number of the worst vertex
            h=i;
        elseif SumaCtvercuAstr(i)==Sort0(param)    %gives the number of the second worst vertex
            s=i;
        else
            if SumaCtvercuAstr(i)==Sort0(1)    %gives the number of the best vertex
                l=i;
            end
        end
    end
    clear SumaCtvercuAstr Sort0;
    
    for i=1:param
        xc(i)=0;
    end
    
    for i=1:param+1                      %calculate the center of the simplexu without the worst vertex i<>h
        if i~=h
            xc(1)=xc(1)+1/param*(p3D(i));    %coordinate of the centre in p3D
            xc(2)=xc(2)+1/param*(t0D(i));    %coordinate of the center in t0D etc...
            xc(3)=xc(3)+1/param*(e3D(i));
            xc(4)=xc(4)+1/param*(aD(i));
            xc(5)=xc(5)+1/param*(i3D(i));
            xc(6)=xc(6)+1/param*(OmegaD(i));
            xc(7)=xc(7)+1/param*(omeg3D(i));
%             xc(8)=xc(8)+1/param*(omegaD(i));
%             xc(9)=xc(9)+1/param*(OmegaD(i));
%             xc(10)=xc(10)+1/param*(excD(i));
%             xc(11)=xc(11)+1/param*(pD(i));
%             xc(12)=xc(12)+1/param*(TD(i));
        end
    end
    %      1      2     3     4      5       6        7       8         9       10      11     12
    xh=[p3D(h),t0D(h),e3D(h),aD(h),i3D(h),OmegaD(h),omeg3D(h)];%,omegaD(h),OmegaD(h),excD(h),pD(h),TD(h)];      %coordinates of the worst vertex
    xl=[p3D(l),t0D(l),e3D(l),aD(l),i3D(l),OmegaD(l),omeg3D(l)];%,omegaD(l),OmegaD(l),excD(l),pD(l),TD(l)];      %coordinates of the best vertex
    xs=[p3D(s),t0D(s),e3D(s),aD(s),i3D(s),OmegaD(s),omeg3D(s)];%,omegaD(s),OmegaD(s),excD(s),pD(s),TD(s)];      %coordinates of the second worst vertex
    
    x=[p3D',t0D',e3D',aD',i3D',OmegaD',omeg3D'];%,omegaD',OmegaD',excD',pD',TD'];  %coordinates of all the 8 vertexes of simplex - in all 7 parametrs
    
    xalfa=(1+alfa)*xc-alfa*xh;    %reflection             !|
%   xbeta=(1-beta)*xc+beta*xh;    %contraction            !|
%   xgama=(1-gama)*xc+gama*xh;    %expansion              !|
    xdelta=xl+delta*(xh-xl);      %shrinkage              !|
%   for beta and gama see lower !

    %-------zde vyjadreni funkcni hodnoty funkce "v bode xalfa"--------
    SumaCtvercuAstrAlfa = CelkemAstro(PocetAstrPouzitych,Wght,HJD,xalfa(2),xalfa(1),xalfa(3),xalfa(4),xalfa(6),xalfa(7),xalfa(5),xBody,yBody);
    %------------------------------------------------------------------
   
    %-------zde vyjadreni funkcni hodnoty funkce "v bode xdelta"--------
    SumaCtvercuAstrDelta = CelkemAstro(PocetAstrPouzitych,Wght,HJD,xdelta(2),xdelta(1),xdelta(3),xdelta(4),xdelta(6),xdelta(7),xdelta(5),xBody,yBody);
    %------------------------------------------------------------------
    
    if SumaCtvercuAstrAlfa < fl
        xgama=(1-gama)*xc+gama*((1+alfa)*xc-alfa*xh);     %xbeta(xalfa(xh)) !
        %-------zde vyjadreni funkcni hodnoty funkce "v bode xgama"--------
        SumaCtvercuAstrGama = CelkemAstro(PocetAstrPouzitych,Wght,HJD,xgama(2),xgama(1),xgama(3),xgama(4),xgama(6),xgama(7),xgama(5),xBody,yBody);
        %------------------------------------------------------------------
        if SumaCtvercuAstrGama < SumaCtvercuAstrAlfa
            for i=1:param
                x(h,i)=xgama(i);
            end
            Inp(abacus-konst)=char('g');
        else
            for i=1:param
                x(h,i)=xalfa(i);
            end
            Inp(abacus-konst)=char('a');
        end
           
    else
        if SumaCtvercuAstrAlfa <= fs
            for i=1:param
                x(h,i)=xalfa(i);
            end
             Inp(abacus-konst)=char('a');
         else
             if SumaCtvercuAstrAlfa > fh
                xbeta=(1-beta)*xc+beta*xh;
                %-------zde vyjadreni funkcni hodnoty funkce "v bode xbeta"--------
                SumaCtvercuAstrBeta = CelkemAstro(PocetAstrPouzitych,Wght,HJD,xbeta(2),xbeta(1),xbeta(3),xbeta(4),xbeta(6),xbeta(7),xbeta(5),xBody,yBody);
                %------------------------------------------------------------------
            else
                xbeta=(1-beta)*xc+beta*((1+alfa)*xc-alfa*xh);     %xbeta(xalfa(xh)) !
                %-------zde vyjadreni funkcni hodnoty funkce "v bode xbeta"--------
                SumaCtvercuAstrBeta = CelkemAstro(PocetAstrPouzitych,Wght,HJD,xbeta(2),xbeta(1),xbeta(3),xbeta(4),xbeta(6),xbeta(7),xbeta(5),xBody,yBody);
                %------------------------------------------------------------------
            end
            if SumaCtvercuAstrBeta > fh
                for j=1:param+1
                   for i=1:param
                       x(j,i)=xl(i)+delta*(x(j,i)-xl(i));
                   end
                end
                Inp(abacus-konst)=char('d');
            else
                for i=1:param
                    x(h,i)=xbeta(i);
                end
                Inp(abacus-konst)=char('b');
            end
        end
    end
    clear t0D p3D e3D aD OmegaD omeg3D i3D;

    for i=1:param+1   %arbitrariness to which vertexes assign which values, in fact we don't know which is now the best and the worst
        p3D(i)=abs(x(i,1));
        t0D(i)=x(i,2);
        if x(i,3) < 0   %negative eccentricities ignore
            e3D(i)=-x(i,3);
        else
            e3D(i)=x(i,3);
        end
        if e3D(i) >= MaxExc
           e3D(i)=MaxExc;
        end

        if x(i,4) < 0
            aD(i)=-x(i,4);     %negative amplitudes ignore
        else
            aD(i)=x(i,4);
        end
        i3D(i)=1/100000000*mod(round(abs(100000000*x(i,5))),36000000000);
        if i3D(i) > 180    %specialni prevod inklinace ze III. a IV. kvadrantu do I. a II.
            i3D(i) = 360-i3D(i);
        end
        OmegaD(i)=1/100000000*mod(round(abs(100000000*x(i,6))),36000000000);
        omeg3D(i)=1/100000000*mod(round(abs(100000000*x(i,7))),36000000000);
    end
end    %k tomu while abacus < count !!
disp([' ']);
disp('Here are shown the individual simplex steps. a-reflection, b-contraction, d-shrinkage, g-expansion');
disp(Inp);

p3=p3D(l);
t0=t0D(l);
e3=e3D(l);
a=aD(l);
i3=i3D(l);
Omega=OmegaD(l);
omeg3=omeg3D(l);

disp([' ']);
disp(['Period of the 3.body: ',num2str(p3,'%3.4f'),' days']);
disp(['Period of the 3.body: ',num2str(p3/365.24,'%3.4f'),' years']);
disp(['T0: ',num2str(t0,'%5.5f'),' JD']);
disp(['eccentricity: ',num2str(e3,'%3.5f'),'  ']);
disp(['Semi major axis: ',num2str(a,'%6.4f'),' arcsec']);
disp(['Inclination: ',num2str(i3,'%6.4f'),' deg']);
disp(['Omega: ',num2str(Omega,'%6.4f'),' deg']);
disp(['omega: ',num2str(omeg3,'%6.4f'),' deg']);

disp(['Altogether: ',int2str(PocetAstrPouzitych),' measurements']);
disp(['The computation ran ', int2str(PocitadloVnejsi), '/',int2str(count)  ' times.']);

if PocitadloVnejsi < count    %podminka ukonceni celeho cyklu!!!
    contin = 1;
else
    contin = 0;
end

end   %end of the whole cycle !!

%----------now plot the resultant figure with final parameters-----------
j=0;
for HJDKrivky = YearToJul(YearAstr(1)):(p3/3000):(YearToJul(YearAstr(1))+p3)     %pro vykresleni krivky pohybu
    j=j+1;
    Hodnota = FcniHodnotaAstrometr(HJDKrivky,t0,p3,e3,a,Omega,omeg3,i3);
    xKrivka(j) = Hodnota(1);     %zde souradnice bodu krivky
    yKrivka(j) = Hodnota(2);
    clear Hodnota;
end
clear HJDKrivky;

Peri = FcniHodnotaAstrometr(t0,t0,p3,e3,a,Omega,omeg3,i3);
xPeri = Peri(1);
yPeri = Peri(2);
Apo = FcniHodnotaAstrometr(t0+p3/2,t0,p3,e3,a,Omega,omeg3,i3);
xApo = Apo(1);
yApo = Apo(2);
clear Peri Apo;

j=0;
for i = 1:PocetAstrPouzitych     %zde jen teoreticke body na krivce pohybu
    j=j+1;
    Hodnota = FcniHodnotaAstrometr(HJD(i),t0,p3,e3,a,Omega,omeg3,i3);
    xOdBodu(j) = Hodnota(1);     %zde souradnice bodu krivky
    yOdBodu(j) = Hodnota(2);
    clear Hodnota;
end

figure(2);
hold on
set(gca,'FontSize',[12]);
  X=[xPeri,xApo];
  Y=[yPeri,yApo];
  set(line(X,Y), 'LineStyle','--', 'Color','black')
  clear X Y;
  plot(0,0,'kx','MarkerSize',13);
plot(xOdBodu,yOdBodu,'r.','MarkerSize',6);  %body na teoreticke krivce
plot(xKrivka,yKrivka,'k.','MarkerSize',1);  % krivka samotna
% plot(xBodyVyraz,yBodyVyraz,'o','MarkerSize',3);    %namerene body
% plot(xOdBoduVyraz,yOdBoduVyraz,'r.','MarkerSize',6);  %body na teoreticke krivce
for i = 1:PocetAstrPouzitych
    X=[xOdBodu(i),xBody(i)];
    Y=[yOdBodu(i),yBody(i)];
    line(X,Y);
    clear X Y;
end
plot(xBody,yBody,'k.','MarkerSize',12);
% for i = 1:pocetvyrazenych
%     XVyraz=[xOdBoduVyraz(i),xBodyVyraz(i)];
%     YVyraz=[yOdBoduVyraz(i),yBodyVyraz(i)];
%     line(XVyraz,YVyraz);
%     clear XVyraz YVyraz;
% end
xlabel('RA[arcsec]');
ylabel('DE[arcsec]');
% axis([-0.07 0.07 -0.125 0.045]);
% set(gca,'PlotBoxAspectRatio',[3 1 1]);
set(gca,'PlotBoxAspectRatio',[1 1 1]);
set(gca,'box','on');

clear CC;
CC=['.png'];
BB=char(Star);
QQ=sprintf([BB CC]);
print('-f', '-dpng', QQ);      %transform the O-C diagram into the .png format
clear CCa;
CCa=['.eps'];
QQ=sprintf([BB CCa]);
print('-f', '-depsc', QQ);      %transform the O-C diagram into the .eps format
hold off
%-------------------------------------------------------------------

%-------------- 
clear CC;
CC=['.txt'];
BB=char(Star);
QQ=sprintf([BB CC]);

% OutputData=[xKrivka; yKrivka];

BB=char(Star);
%-------------- O U T P U T   DATA FILE --------------->>>
fid = fopen(QQ,'w');
fprintf(fid,'%s',BB,': Theoretical curve: X -- Y');
fprintf(fid,'%s\n','');
for i = 1:length(xKrivka)
    fprintf(fid,'%2.7f    %2.7f\n',xKrivka(i),yKrivka(i));
end
fprintf(fid,'%s\n','');
fprintf(fid,'%s\n','');
fprintf(fid,'%s',BB,': The data: observed X -- Y , theoretical X -- Y');
fprintf(fid,'%s\n','');
for i = 1:length(xBody)
    fprintf(fid,'%2.7f     %2.7f      %2.7f     %2.7f\n',xBody(i),yBody(i),xOdBodu(i),yOdBodu(i));
end
status=fclose('all');
%-------------- 
clear OutputData QQ BB CC fid;

clear xKrivka yKrivka;
% disp(['omega: ',num2str(omeg3*180/pi,'%6.4f'),' rad']);

CC=['        ; 1=compute(fit), 0=not compute(fix)'];
BBa=char(Star);
QQ=sprintf([BBa CC]);
%-------------- O U T P U T --------------->>>
fid = fopen('Parameters.txt','w');
fprintf(fid,'%s\n',QQ');
fprintf(fid,'%5.6f',p3);
fprintf(fid,'%s','      ');
fprintf(fid,'%1.0f',p3F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','  p3 [days]');
fprintf(fid,'%5.6f',t0);
fprintf(fid,'%s','   ');
fprintf(fid,'%1.0f',t0F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','  T0 [JD]');
fprintf(fid,'%4.6f',e3);
fprintf(fid,'%s','        ');
fprintf(fid,'%1.0f',e3F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','   e3 ');
fprintf(fid,'%6.6f',a);
fprintf(fid,'%s','        ');
fprintf(fid,'%1.0f',aF);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','   a [arcsec]');
fprintf(fid,'%6.6f',i3);
fprintf(fid,'%s','       ');
fprintf(fid,'%1.0f',i3F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','   i3 [deg]');
fprintf(fid,'%5.6f',Omega);
fprintf(fid,'%s','       ');
fprintf(fid,'%1.0f',OmegaF);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','  Omega [deg]');
fprintf(fid,'%7.6f',omeg3);
fprintf(fid,'%s','        ');
fprintf(fid,'%1.0f',omeg3F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','  omeg3 [deg]');
status=fclose('all');

%-------------- O U T P U T --------------->>>
fid = fopen('Output.txt','w');
fprintf(fid,'%s',BBa,': Final parameters');
fprintf(fid,'%s\n','');
fprintf(fid,'%s\n','');
fprintf(fid,'%s','p3 = ');
fprintf(fid,'%4.5f',p3);
fprintf(fid,'%s\n',' days');
fprintf(fid,'%s','p3 = ');
fprintf(fid,'%5.4f',p3/365.24);
fprintf(fid,'%s\n',' years');
fprintf(fid,'%s','T0 = ');
fprintf(fid,'%10.3f',t0);
fprintf(fid,'%s\n',' HJD');
fprintf(fid,'%s','e = ');
fprintf(fid,'%2.5f',e3);
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s','a = ');
fprintf(fid,'%3.6f',a);
fprintf(fid,'%s\n',' arcsec');
fprintf(fid,'%s','i = ');
fprintf(fid,'%5.4f',i3);
fprintf(fid,'%s\n',' deg');
fprintf(fid,'%s','Omega = ');
fprintf(fid,'%5.6f',Omega);
fprintf(fid,'%s\n',' deg');
fprintf(fid,'%s','omega = ');
fprintf(fid,'%7.6f',omeg3);
fprintf(fid,'%s\n',' deg');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s','SUM of the square residuals: ');
fprintf(fid,'%1.13f\n',fl);
status=fclose('all');

%-----------------------------------------------------------------------
figure(12);
% plot(PocitadloProGraf,SumaProGraf,'k.','MarkerSize',1);
plot(SumaProGraf,'.');
%-----------------------------------------------------------------------

% disp([' ']);
% disp(['Chyba p3: ',num2str(deltap3,'%8.4f'),' dny => ',num2str(100*deltap3/p3,'%5.4f'),' %']);
% disp(['Chyba T0: ',num2str(deltat0,'%8.4f'),' dny => ',num2str(100*deltat0/t0,'%5.4f'),' %']);
% disp(['Chyba a: ',num2str(deltaa,'%3.4f'),' arcsec => ',num2str(100*deltaa/a,'%5.4f'),' %']);
% disp(['Chyba e: ',num2str(deltae3,'%3.6f'),' => ',num2str(100*deltae3/e3,'%5.4f'),' %']);
% disp(['Chyba i3: ',num2str(deltai3,'%5.4f'),' deg => ',num2str(100*deltai3/i3,'%5.4f'),' %']);
% disp(['Chyba Omega: ',num2str(deltaOmega,'%5.4f'),' deg => ',num2str(100*deltaOmega/Omega,'%5.4f'),' %']);
% disp(['Chyba omega3: ',num2str(deltaomeg3,'%5.4f'),' deg => ',num2str(100*deltaomeg3/omeg3,'%5.4f'),' %']);
